package fr.smallcrew.rest.controller;

import com.google.common.base.Splitter;
import fr.smallcrew.rest.exception.ResourceNotFoundException;
import org.springframework.web.HttpRequestHandler;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

public class DefaultController implements HttpRequestHandler {
  public static final Splitter uriSplitter = Splitter.on(".");

  @Override
  public void handleRequest(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    throw new ResourceNotFoundException("Invalid resource '" + uriWithoutExtension(request.getRequestURI()) + "'");
  }

  private String uriWithoutExtension(String uri) {
    return uriSplitter.split(uri).iterator().next();
  }
}
