package fr.smallcrew.rest.converter;

import org.springframework.http.HttpInputMessage;
import org.springframework.http.HttpOutputMessage;
import org.springframework.http.MediaType;
import org.springframework.http.converter.HttpMessageNotReadableException;
import org.springframework.http.converter.HttpMessageNotWritableException;

import java.io.IOException;
import java.util.List;
import java.util.Set;

public interface RestConverter {
  void addPackage(Set<String> packageName);

  void addClasses(Set<String> className);

  void consolidate();

  boolean supports(Class<?> clazz);

  Object readInternal(Class<?> clazz, HttpInputMessage inputMessage) throws IOException, HttpMessageNotReadableException;

  void writeInternal(Object o, HttpOutputMessage outputMessage) throws IOException, HttpMessageNotWritableException;

  List<MediaType> getSupportedMediaTypes();

  void write(Object o, MediaType contentType, HttpOutputMessage outputMessage) throws IOException, HttpMessageNotWritableException;
}
