package fr.smallcrew.rest.data;

import org.springframework.data.domain.Sort;

import java.util.Collection;
import java.util.Iterator;

import static com.google.common.collect.Lists.newArrayList;

public class WebSort implements Iterable<WebSortOrder> {
  private Collection<WebSortOrder> orders;

  public WebSort() {
    orders = newArrayList();
  }

  public WebSort(Sort sort) {
    this();
    if (sort != null) {
      for (Sort.Order order : sort) {
        orders.add(new WebSortOrder(order));
      }
    }
  }

  public Collection<WebSortOrder> getOrders() {
    return orders;
  }

  public void setOrders(Collection<WebSortOrder> orders) {
    this.orders = orders;
  }

  @Override
  public Iterator<WebSortOrder> iterator() {
    return orders.iterator();
  }
}
