package fr.smallcrew.rest.servlet;

import fr.smallcrew.rest.controller.DefaultController;
import org.springframework.web.context.WebApplicationContext;
import org.springframework.web.servlet.DispatcherServlet;
import org.springframework.web.servlet.HandlerExecutionChain;

import javax.servlet.http.HttpServletRequest;

public class APIServlet extends DispatcherServlet {
  private static final long serialVersionUID = -3804257359099120923L;
  public final HandlerExecutionChain notFoundHandler;

  public APIServlet() {
    notFoundHandler = newNotFoundHandler();
  }

  public APIServlet(WebApplicationContext webApplicationContext) {
    super(webApplicationContext);
    notFoundHandler = newNotFoundHandler();
  }

  @Override
  protected HandlerExecutionChain getHandler(HttpServletRequest request) throws Exception {
    HandlerExecutionChain handler = super.getHandler(request);
    if (handler == null) {
      return notFoundHandler;
    }
    return handler;
  }

  private HandlerExecutionChain newNotFoundHandler() {
    return new HandlerExecutionChain(new DefaultController());
  }
}
